/*
  Tabela REQUESTO:
         Requisies de Estoque
  Descrio :
      Insere registros na tabela LOGOPERA a partir de alteraes na tabela REQUESTO
  Objetivo  :
      Gerar um log que vai registrar as alteraes na tabela REQUESTO utilizando a
      tabela Geral de Logs de Operaes
@C:\WEB_411\Sql\End_Conv\Oracle\02FT_ESTTRGO_LOG_EST_REQUESTO.SQL      
*/

CREATE OR REPLACE TRIGGER LOG_EST_REQUESTO
AFTER DELETE OR INSERT OR UPDATE
ON REQUESTO FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';
   IF DELETING THEN

      V_DESC := V_DESC || 'Filial='        || :OLD.CDFILIAL;
      V_DESC := V_DESC || ' NrRequesicao=' || :OLD.NRREQUESTO;
      V_DESC := V_DESC || ' DtRequisicao=' || :OLD.DTREQUESTO;
      V_DESC := V_DESC || ' DtPrevisao='   || :OLD.DTPREVREQU;
      V_DESC := V_DESC || ' Descrisao='    || :OLD.DSREQUESTO;
      V_DESC := V_DESC || ' CentroCusto='  || :OLD.CDCENTCUST;
      V_DESC := V_DESC || ' Operador='     || :OLD.CDOPERREQU;
      V_DESC := V_DESC || ' Almox Said='   || :OLD.CDALMOXSAID;
      V_DESC := V_DESC || ' Local Said='   || :OLD.CDLCESTSAID;
      V_DESC := V_DESC || ' Almox Ent='    || :OLD.CDALMOXENTR;
      V_DESC := V_DESC || ' Local Ent='    || :OLD.CDLCESTENTR;
      V_DESC := V_DESC || ' Setor='        || :OLD.CDSETOR;
      V_DESC := V_DESC || ' Almox Said='   || :OLD.CDALMOXSAID;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRREQUESTO;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.DTREQUESTO,SYSDATE)  <> NVL(:NEW.DTREQUESTO,SYSDATE))  OR
            (NVL(:OLD.DTPREVREQU,SYSDATE)  <> NVL(:NEW.DTPREVREQU,SYSDATE))  OR
            (NVL(:OLD.DSREQUESTO,'#')  <> NVL(:NEW.DSREQUESTO,'#'))  OR
            (NVL(:OLD.CDCENTCUST,'#')  <> NVL(:NEW.CDCENTCUST,'#'))  OR
            (NVL(:OLD.CDOPERREQU,'#')  <> NVL(:NEW.CDOPERREQU,'#'))  OR
            (NVL(:OLD.CDALMOXSAID,'#') <> NVL(:NEW.CDALMOXSAID,'#'))  OR
            (NVL(:OLD.CDLCESTSAID,'#') <> NVL(:NEW.CDLCESTSAID,'#'))  OR
            (NVL(:OLD.CDALMOXENTR,'#') <> NVL(:NEW.CDALMOXENTR,'#'))  OR
            (NVL(:OLD.CDLCESTENTR,'#') <> NVL(:NEW.CDLCESTENTR,'#'))  OR
            (NVL(:OLD.CDSETOR,'#')     <> NVL(:NEW.CDSETOR,'#'))      THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRREQUESTO;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRREQUESTO;
      END IF;

      IF (NVL(:OLD.DTREQUESTO,SYSDATE)  <> NVL(:NEW.DTREQUESTO,SYSDATE)) THEN
         V_DESC := V_DESC || ' DtRequisicao=' || :NEW.DTREQUESTO;
      END IF;

      IF (NVL(:OLD.DTPREVREQU,SYSDATE)  <> NVL(:NEW.DTPREVREQU,SYSDATE)) THEN
         V_DESC := V_DESC || ' DtPrevisao='   || :NEW.DTPREVREQU;
      END IF;

      IF (NVL(:OLD.DSREQUESTO,'#')  <> NVL(:NEW.DSREQUESTO,'#')) THEN
         V_DESC := V_DESC || ' Descrisao='    || :NEW.DSREQUESTO;
      END IF;

      IF (NVL(:OLD.CDCENTCUST,'#')  <> NVL(:NEW.CDCENTCUST,'#')) THEN
         V_DESC := V_DESC || ' CentroCusto='  || :NEW.CDCENTCUST;
      END IF;

      IF (NVL(:OLD.CDOPERREQU,'#')  <> NVL(:NEW.CDOPERREQU,'#')) THEN
         V_DESC := V_DESC || ' Operador='     || :NEW.CDOPERREQU;
      END IF;
      IF (NVL(:OLD.CDALMOXSAID,'#') <> NVL(:NEW.CDALMOXSAID,'#'))THEN
         V_DESC := V_DESC || ' Almox Said='   || :NEW.CDALMOXSAID;
      END IF;
      IF (NVL(:OLD.CDLCESTSAID,'#') <> NVL(:NEW.CDLCESTSAID,'#'))THEN
         V_DESC := V_DESC || ' Local Said='   || :NEW.CDLCESTSAID;
      END IF;
      IF (NVL(:OLD.CDALMOXENTR,'#') <> NVL(:NEW.CDALMOXENTR,'#'))THEN
         V_DESC := V_DESC || ' Almox Ent='    || :NEW.CDALMOXENTR;
      END IF;
      IF (NVL(:OLD.CDLCESTENTR,'#') <> NVL(:NEW.CDLCESTENTR,'#'))THEN
         V_DESC := V_DESC || ' Local Ent='    || :NEW.CDLCESTENTR;
      END IF;
      IF(NVL(:OLD.CDSETOR,'#')     <> NVL(:NEW.CDSETOR,'#'))  THEN
         V_DESC := V_DESC || ' Setor='        || :NEW.CDSETOR;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);

      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
                 (NMTABELA,     DTOPERACAO,   NMRESPOPER, IDTIPOOPER,    DSOPERACAO, CDPESQITEM,
                  DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
              VALUES
                 ('REQUESTO', SYSDATE, NVL(V_USUARIO,' '), V_TIPO, V_DESC,
                  V_ITPESQ, V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD,
                  V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_EST_REQUESTO','5.01.017'); END;
/
