/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: APURAC_RELMANDATO

DESCRIO:
   PROCEDIMENTO PARA GERAO E TOTALIZAO DOS DADOS GERADOS PELA APURAO
   DE FATURAMENTO DE CLIENTES EM FILIAIS QUE UTILIZAM O TIPO DE CONTRATO MANDATO.

--   RAISERRO('TESTE',16,1);
*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_RELMANDATO' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_RELMANDATO
GO

CREATE PROCEDURE APURAC_RELMANDATO(
      @P_CDFILIPROC         VARCHAR(04),
      @P_SEQUMAND           VARCHAR(10),
      @P_CDCLIENTE          VARCHAR(21),
      @P_CDFILIAPUR         VARCHAR(04),
      @P_NRAPURACFAT        VARCHAR(10),
      @P_NRLANCTONF         VARCHAR(10),
      @P_DTINIAPUR          DATETIME = NULL,
      @P_DTFINAPUR          DATETIME = NULL
) AS

    DECLARE  @V_CDEMPRATAC    VARCHAR(02);
    DECLARE  @V_CDINSCATAC    VARCHAR(16);
    DECLARE  @V_CDINSCMUNI    VARCHAR(16);
    DECLARE  @V_CDEMPROPER    VARCHAR(02);
    DECLARE  @V_CDSERIE       VARCHAR(05);
    DECLARE  @V_CDSERIEDESP   VARCHAR(05);
    DECLARE  @V_CDIMPOSTO     VARCHAR(02);

    DECLARE  @V_CDFILIAPUR    VARCHAR(04);
    DECLARE  @V_DTINIAPURAC   DATETIME;
    DECLARE  @V_DTFIMAPURAC   DATETIME;

    DECLARE  @V_CONTADOR      VARCHAR(10);
    DECLARE  @V_VRBASENFCMP   DOUBLE PRECISION;
    DECLARE  @V_VRBRUTITEM    DOUBLE PRECISION;

    DECLARE  @V_CDPRGENEREV   VARCHAR(10);

    DECLARE  @V_CDTIPOOPER    VARCHAR(02)

	 DECLARE  @V_IDTAXAADM     VARCHAR(01);
    DECLARE  @V_IDCALCCOMPR   VARCHAR(01);
    DECLARE  @V_IDRECUIMPOS   VARCHAR(01);

    DECLARE  @V_VRTAXAADM     DOUBLE PRECISION;
    DECLARE  @V_VRTOTAXAADM   NUMERIC(16, 5);
    DECLARE  @V_VRPCTXADM     FLOAT;
    DECLARE  @V_VRLIQUFATU    FLOAT;
    DECLARE  @V_VRPERCDESP    NUMERIC(16,5);
    DECLARE  @V_VRTOTADESP    NUMERIC(16,5);
    DECLARE  @V_VRTOTACMP     NUMERIC(16,5);
    DECLARE  @V_VRRECUIMCMP   NUMERIC(16,5)
    DECLARE  @V_VRRECUIMDES   NUMERIC(16,5);

    DECLARE  @V_NUMITENS      NUMERIC(16,5);

    DECLARE  @V_IDNFPRODREV   VARCHAR(01);
    DECLARE  @V_PAISORIG      VARCHAR(04);
    DECLARE  @V_ESTAORIG      VARCHAR(02);
    DECLARE  @V_MUNIORIG      VARCHAR(04);
    DECLARE  @V_PAISDEST      VARCHAR(04);
    DECLARE  @V_ESTADEST      VARCHAR(02);
    DECLARE  @V_IDENDCFOP     VARCHAR(01);
    DECLARE  @V_IDENDEMIS     VARCHAR(01);
    DECLARE  @V_IDGEROUNF     VARCHAR(01);
    DECLARE  @V_CDEMPRESA     VARCHAR(02);
    DECLARE  @V_CDINSCESTA    VARCHAR(16);
    DECLARE  @V_CDGRUPOFISC   VARCHAR(03);

    DECLARE  @V_SERIE         VARCHAR(05);
    DECLARE  @V_INSCESTA      VARCHAR(16);
    DECLARE  @V_INSCMUNI      VARCHAR(16);

    DECLARE  @V_SOMAALQIMP   NUMERIC(16,5);
    DECLARE  @V_VRCUSTOMED   NUMERIC(16,5);
    DECLARE  @V_VRALIQUTMP   NUMERIC(16,5);

    DECLARE  @V_VRTXADMPROD  NUMERIC(16,5);
    DECLARE  @V_TIPOOPER     VARCHAR(02);
    DECLARE  @V_VRFATOCONV   NUMERIC(16,5);
    DECLARE  @V_NMPRODUTO    VARCHAR(50);
    DECLARE  @V_CDPRODUTO    VARCHAR(10);
    DECLARE  @V_IDFATPRODCLI VARCHAR(01);
    DECLARE  @V_QTDESCIT     NUMERIC(16,5);
    DECLARE  @V_QTDESCIT1    NUMERIC(16,5);
    DECLARE  @V_VRTXFATNIV   NUMERIC(16,5);
    DECLARE  @V_VRDESCNFCMP  NUMERIC(16,5);
    DECLARE  @V_VRTOTCMPSTX  NUMERIC(16,5);
    DECLARE  @V_VRTOTCMPCTX  NUMERIC(16,5);
    DECLARE  @V_VRTOTDESCTX  NUMERIC(16,5);
    DECLARE  @V_VRTOTDESSTX  NUMERIC(16,5);
    DECLARE  @V_VRDOTPURPASS NUMERIC(16,5);

/*VARIVEIS DO CURSOR C_DESPADMFATUR*/
    DECLARE @CDFILIAL         VARCHAR(04);
    DECLARE @CDDESPADMFAT     VARCHAR(02)
    DECLARE @DTLANCDESFAT     DATETIME;
    DECLARE @VRLANCDESFAT     FLOAT;
    DECLARE @CDGRUPOFATUR     VARCHAR(02);
    DECLARE @CDPRODUTO        VARCHAR(10);
    DECLARE @DSDESPADMFAT     VARCHAR(40);
    DECLARE @VRTAXADMFATU     FLOAT;

    /*VARIVEIS DO CURSOR C_TAXA*/
    DECLARE @V_FILIAL   VARCHAR(04);
    DECLARE @V_PRODUTO  VARCHAR(10);
    DECLARE @V_BRUTITEM DOUBLE PRECISION;
BEGIN
   SET @V_IDGEROUNF    = 'N';
   SET @V_CONTADOR     = 0;
   SET @V_SOMAALQIMP   = 0;
   SET @V_VRTOTADESP   = 0;
   SET @V_VRTXFATNIV   = 0;
   SET @V_VRDESCNFCMP  = 0;
   SET @V_VRRECUIMCMP  = 0;
   SET @V_VRRECUIMDES  = 0;
   SET @V_VRTOTACMP    = 0;
   SET @V_VRTOTCMPSTX  = 0;
   SET @V_VRTOTCMPCTX  = 0;
   SET @V_VRTOTDESSTX  = 0;
   SET @V_VRTOTDESCTX  = 0;
   SET @V_VRDOTPURPASS = 0;
   SET @V_VRLIQUFATU   = 0;
   SET @V_VRBASENFCMP  = 0;

---------------------------------------------------------------------------------
-- DELETA OS REGISTROS DA TABELA TEMPORARIA                                  --
---------------------------------------------------------------------------------
   DELETE FROM RELAT_MANDATO
   WHERE NRRELATMANDA = @P_SEQUMAND;


   /* FILIAL QUE EST SENDO APURADA (@P_FILIAL = FILIPROC)*/
   SELECT @V_CDFILIAPUR  = MAX(CDFILIAPUR),
          @V_DTINIAPURAC = MAX(DTINIAPURAC)
   FROM   CTRLAPURFAT
   WHERE CDFILIAL    = @P_CDFILIPROC   AND
         NRAPURACFAT = @P_NRAPURACFAT;

   SELECT @V_DTINIAPURAC = MAX(DTINIAPURAC),
          @V_DTFIMAPURAC = MAX(DTFIMAPURAC)
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = @V_CDFILIAPUR   AND
         DTINIAPURAC < @V_DTINIAPURAC;

   SELECT @V_VRPCTXADM   = CONVERT(NUMERIC,ISNULL(MAX(SUBSTRING(PF.DSPARAMFATFI,31,6)), 0)), /*PERCENTUAL DE COMPRAS/REVENDA*/
          @V_CDEMPRATAC  = MAX(SUBSTRING(PF.DSPARAMFATFI,39,2)),          /*EMPRESA ATACADISTA*/
          @V_CDEMPROPER  = MAX(SUBSTRING(PF.DSPARAMFATFI,41,2)),          /*EMPRESA OPERACIONAL*/
          @V_IDTAXAADM   = MAX(SUBSTRING(PF.DSPARAMFATFI,43,1)),          /*TAXA DE ADMINISTRACAO*/
          @V_CDPRGENEREV = RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,73,10))),  /*CODIGO DA PRODUTO PARA REVENDA*/
          @V_IDCALCCOMPR = MAX(SUBSTRING(PF.DSPARAMFATFI,49,1)),          /*CALCULO VALOR TOTAL DE COMPRAS*/
          @V_IDRECUIMPOS = MAX(SUBSTRING(PF.DSPARAMFATFI,37,1)),          /*RECUPERAO DE IMPOSTOS*/
          @V_VRPERCDESP  = MAX(SUBSTRING(PF.DSPARAMFATFI,63,6)),         /*PERCENTUAL DE DESPESAS*/
          @V_IDNFPRODREV = MAX(SUBSTRING(PG.DSPARAMFATGE,155,1))         /*GERA NF DE PRODUTO PARA REVENDA*/
   FROM PARAMFILIAL PF, PARAMGERAL PG
   WHERE PF.CDFILIAL = @V_CDFILIAPUR;

   SET @V_VRPCTXADM   = @V_VRPCTXADM/1000;
   SET @V_VRPERCDESP  = @V_VRPERCDESP/1000;

   IF (@V_CDTIPOOPER IS NULL) OR (@V_CDTIPOOPER = ' ') BEGIN
      SET @V_CDTIPOOPER = '01';
   END;

   SELECT @V_SERIE = MAX(CDSERIE), @V_INSCESTA = MAX(CDINSCESTA), @V_INSCMUNI = MAX(CDINSCMUNI)
   FROM FILIAL F
   WHERE F.CDFILIAL  = @V_CDFILIAPUR   AND
         F.CDEMPRESA = @V_CDEMPRATAC;

   SELECT @V_CDSERIE = MAX(CDSERIE), @V_CDINSCATAC = MAX(CDINSCESTA), @V_CDINSCMUNI = MAX(CDINSCMUNI)
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = @V_CDFILIAPUR   AND
         F.CDEMPRESA = @V_CDEMPRATAC;

   SELECT @V_CDSERIEDESP = MAX(CDSERIE)
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = @V_CDFILIAPUR   AND
         F.CDEMPRESA = @V_CDEMPROPER;

   IF @V_CDSERIE IS NULL BEGIN
      SET @V_CDSERIE    = @V_SERIE;
      SET @V_CDINSCATAC = @V_INSCESTA;
      SET @V_CDINSCMUNI = @V_INSCMUNI;
   END;

   IF @V_CDSERIEDESP IS NULL BEGIN
      SET @V_CDSERIE = @V_SERIE;
   END;

   SELECT @V_CDIMPOSTO = MAX(CDIMPOSTO)
   FROM IMPOSMRDP
   WHERE IDIMPOMRDP = 'P';

   SELECT @V_VRBASENFCMP = MAX(ISNULL(VRDESCENTAPU,0))
   FROM CTRLAPURFAT
   WHERE (NRAPURACFAT = @P_NRAPURACFAT)  AND
         (CDFILIAPUR  = @P_CDFILIAPUR);

   IF @V_VRBASENFCMP <> 0 BEGIN
      SELECT @V_VRDESCNFCMP = ISNULL(SUM(VRBRUTITEM),0), @V_NUMITENS = COUNT(IP.CDPRODUTO)
      FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX
      WHERE N.CDFILIAPFATU     = @P_CDFILIPROC            AND
            N.NRAPFATUTNF      = @P_NRAPURACFAT           AND
            IP.CDFILIAL        = N.CDFILIAL               AND
            IP.NRLANCTONF      = N.NRLANCTONF             AND
            IP.CDFILIAL        = TX.CDFILIAL              AND
            (CHARINDEX(ISNULL(TX.CDPRODUTO,''), IP.CDPRODUTO) = 1);

      IF @V_VRDESCNFCMP <> 0 BEGIN
         SET @V_VRDESCNFCMP = ((@V_VRDESCNFCMP - @V_VRBASENFCMP) / @V_NUMITENS);
      END;
   END;

   DECLARE C_TAXA CURSOR FOR
   SELECT IP.CDFILIAL, IP.CDPRODUTO, VRBRUTITEM
   FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX
   WHERE N.CDFILIAPFATU     = @P_CDFILIPROC              AND
         N.NRAPFATUTNF      = @P_NRAPURACFAT             AND
         N.CDTIPOOPER <> '12'                            AND
         IP.CDFILIAL        = N.CDFILIAL                 AND
         IP.NRLANCTONF      = N.NRLANCTONF               AND
         IP.CDFILIAL        = TX.CDFILIAL                AND
         (CHARINDEX(ISNULL(TX.CDPRODUTO,''), IP.CDPRODUTO) = 1)
   ORDER BY 2

   OPEN C_TAXA;
   FETCH NEXT FROM C_TAXA INTO @V_FILIAL, @V_PRODUTO, @V_BRUTITEM

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT @V_IDFATPRODCLI = MAX(IDFATPRODCLI)
      FROM PRODFILIFATU
      WHERE CDFILIAL      = @V_FILIAL   AND
            (CHARINDEX(ISNULL(CDPRODUTO,''), @V_PRODUTO) = 1) AND
            (CDTPFATPRFIL  = '003');

      SET @V_VRBRUTITEM = (@V_BRUTITEM - @V_VRDESCNFCMP);

      SELECT @V_VRTXFATNIV = ISNULL(MAX(VRTAXADMFATU),0)
      FROM TAXAADMFATUR TX
      WHERE (TX.CDFILIAL  = @V_FILIAL) AND
            (CHARINDEX(ISNULL(TX.CDPRODUTO,''), @V_PRODUTO) = 1);

      IF @V_VRTXFATNIV <> 0 BEGIN
         SET @V_VRTAXAADM = ((@V_VRBRUTITEM) * (@V_VRTXFATNIV / 100));
      END
      ELSE BEGIN
         SET @V_VRTAXAADM = (@V_VRBRUTITEM * (@V_VRPCTXADM / 100));
      END;

      IF (@V_IDFATPRODCLI  = '1') OR (@V_IDFATPRODCLI IS NULL) BEGIN
         IF @V_IDCALCCOMPR = '1' BEGIN
            SET @V_VRLIQUFATU = @V_VRLIQUFATU  + ((@V_VRBRUTITEM + ISNULL(@V_VRTAXAADM,0)));
         END
         ELSE BEGIN
            SET @V_VRLIQUFATU =  @V_VRLIQUFATU + (ISNULL(@V_VRTAXAADM,0));
         END;
         SET @V_VRTOTCMPSTX = (@V_VRTOTCMPSTX + @V_VRBRUTITEM);
         SET @V_VRTOTCMPCTX = (@V_VRTOTCMPCTX + @V_VRTAXAADM);
      END
      ELSE BEGIN
         IF (@V_IDFATPRODCLI  = '2') BEGIN
            SET @V_VRTOTCMPSTX = (@V_VRTOTCMPSTX + @V_VRBRUTITEM);
         END;
      END;

      FETCH NEXT FROM C_TAXA INTO @V_FILIAL, @V_PRODUTO, @V_BRUTITEM
   END;
   CLOSE C_TAXA;
   DEALLOCATE C_TAXA;

   IF NOT (ISNULL(@V_IDNFPRODREV,'N') = 'S') BEGIN

      IF @V_VRLIQUFATU > 0 BEGIN

         IF @V_IDRECUIMPOS = 'S' BEGIN

            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT @V_IDENDCFOP = MAX(ISNULL(IDENDCFOPFIL,'I')),
                   @V_CDEMPRESA = MAX(CDEMPRESA),
                   @V_CDINSCESTA = MAX(CDINSCESTA)
            FROM FILIAL
            WHERE (CDFILIAL = @P_CDFILIAPUR);

            IF @V_IDENDCFOP = 'I' BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS),
                      @V_ESTAORIG = MAX(SGESTADO),
                      @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM INSCRESTAD
               WHERE CDEMPRESA  = @V_CDEMPRESA AND
                     CDINSCESTA = @V_CDINSCESTA;
            END
            ELSE BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS),
                      @V_ESTAORIG = MAX(SGESTADO),
                      @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM ENDEFILI
               WHERE (CDFILIAL     = @P_CDFILIAPUR) AND
                     (IDTPENDEFILI = @V_IDENDCFOP);
            END;

            SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'),
                   @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
            FROM CLIENTE
            WHERE (CDCLIENTE = @P_CDCLIENTE);

            SELECT @V_PAISDEST = MAX(CDPAIS),
                   @V_ESTADEST = MAX(SGESTADO)
            FROM ENDECLIE
            WHERE (CDCLIENTE    = @P_CDCLIENTE) AND
                  (IDTPENDECLIE = @V_IDENDEMIS);

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE , @V_CDFILIAPUR, 'S', @V_CDTIPOOPER, @V_CDGRUPOFISC;

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            /* ISS */

            EXEC CONSULTA_ALIQUOTA '31', 'S',  @V_CDEMPRATAC, @V_CDPRGENEREV, @V_CDINSCATAC, @V_PAISORIG,
                                    @V_ESTAORIG,  @V_PAISDEST,  @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DTFINAPUR,
                                    @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            /* PIS */

            EXEC CONSULTA_ALIQUOTA '50', 'S', @V_CDEMPRATAC, @V_CDPRGENEREV, @V_CDINSCATAC, @V_PAISORIG,
                                    @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DTFINAPUR,
                                    @P_CDFILIAPUR, @P_NRLANCTONF,  @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

             /* COFINS */

            EXEC CONSULTA_ALIQUOTA '60', 'S', @V_CDEMPRATAC, @V_CDPRGENEREV, @V_CDINSCATAC, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DTFINAPUR,
                                   @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

            SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

            SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

            IF @V_SOMAALQIMP <>  0 BEGIN
                IF @V_IDTAXAADM = 'D' BEGIN  /*POR DENTRO*/
                    SET @V_VRRECUIMCMP = (@V_SOMAALQIMP / 100);
                END
                ELSE BEGIN                      /*POR FORA*/
                   SET @V_VRRECUIMCMP = (100 / (100 - @V_SOMAALQIMP));
                END;
            END;

         END;
         SET @V_VRLIQUFATU = (@V_VRLIQUFATU * @V_VRRECUIMCMP);
         SET @V_IDGEROUNF  = 'S';
         SET @V_VRTOTACMP  = @V_VRLIQUFATU;
      END;
   END;

   INSERT INTO RELAT_MANDATO
      (CDFILIAL, NRRELATMANDA, NRREGRELMAND, CDCLIENTEMA, CDFILIAPURMA, NRAPURACFAMA,
       CDPRODCMPMAN,VRTOTACMPSTX, VRTOTACMPCTX, VRPERECIMCMP, VRRECUPIMCMP, VRTOTCMPAPUR)
       VALUES
      (@P_CDFILIPROC, @P_SEQUMAND, @V_CONTADOR, @P_CDCLIENTE, @P_CDFILIAPUR, @P_NRAPURACFAT,
       @V_CDPRGENEREV,@V_VRTOTCMPSTX,  @V_VRTOTCMPCTX, @V_SOMAALQIMP, @V_VRRECUIMCMP, @V_VRTOTACMP);

   SET @V_CONTADOR = @V_CONTADOR + 1;

   /*INCLUSO DO ITENS DA DESPESA ADMINISTRATIVAS LANADAS NO FAI*/
   DECLARE C_DESPADMFATUR CURSOR FOR
   SELECT L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
          D.CDGRUPOFATUR, D.CDPRODUTO, D.DSDESPADMFAT, ISNULL(L.VRTXLANCDESP,0)
   FROM LANCDESPFATU L,  DESPADMFATUR D
   WHERE (L.CDFILIAL = @P_CDFILIAPUR)                            AND
         (D.CDDESPADMFAT = L.CDDESPADMFAT)                      AND
         (L.DTLANCDESFAT BETWEEN @P_DTINIAPUR AND @P_DTFINAPUR)
   GROUP BY D.CDGRUPOFATUR, L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
            D.CDPRODUTO, D.DSDESPADMFAT, ISNULL(L.VRTXLANCDESP,0);

   OPEN C_DESPADMFATUR;
   FETCH NEXT FROM C_DESPADMFATUR INTO  @CDFILIAL, @CDDESPADMFAT, @DTLANCDESFAT,
                                        @VRLANCDESFAT, @CDGRUPOFATUR, @CDPRODUTO,
                                        @DSDESPADMFAT, @VRTAXADMFATU;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_VRTOTDESSTX = (@V_VRTOTDESSTX + @VRLANCDESFAT);

      IF @VRTAXADMFATU <> 0  BEGIN
         SET @V_VRTAXAADM = (@VRLANCDESFAT * (@VRTAXADMFATU / 100));
      END
      ELSE BEGIN
         SET @V_VRTAXAADM = (@VRLANCDESFAT * (@V_VRPERCDESP / 100));
      END;

      SELECT @V_IDFATPRODCLI = MAX(IDFATPRODCLI)
      FROM PRODFILIFATU
      WHERE CDFILIAL      = @CDFILIAL   AND
            (CHARINDEX(ISNULL(CDPRODUTO,''), @CDPRODUTO) = 1)  AND
            (CDTPFATPRFIL  = '003');

      IF  (@V_IDFATPRODCLI  = '1') OR (@V_IDFATPRODCLI IS NULL) BEGIN
         SET @V_VRLIQUFATU  = (@VRLANCDESFAT  + ISNULL(@V_VRTAXAADM,0));
         SET @V_VRTOTDESCTX = (@V_VRTOTDESCTX + ISNULL(@V_VRTAXAADM,0));
      END
      ELSE BEGIN
         IF (@V_IDFATPRODCLI  = '2') BEGIN
            SET @V_VRLIQUFATU = (@VRLANCDESFAT);
         END;
      END;

      IF @V_IDRECUIMPOS = 'S' BEGIN

         SET @V_SOMAALQIMP = 0;

         IF @V_IDGEROUNF = 'S' BEGIN

            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT @V_IDENDCFOP  = MAX(ISNULL(IDENDCFOPFIL,'I')),
                   @V_CDEMPRESA  = MAX(CDEMPRESA),
                   @V_CDINSCESTA = MAX(CDINSCESTA)
            FROM FILIAL
            WHERE (CDFILIAL = @P_CDFILIAPUR);

            IF @V_IDENDCFOP = 'I' BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS),
                      @V_ESTAORIG = MAX(SGESTADO),
                      @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM INSCRESTAD
               WHERE CDEMPRESA  = @V_CDEMPRESA AND
                     CDINSCESTA = @V_CDINSCESTA;
            END
            ELSE BEGIN
               SELECT @V_PAISORIG = MAX(CDPAIS),
                      @V_ESTAORIG = MAX(SGESTADO),
                      @V_MUNIORIG = MAX(CDMUNICIPIO)
               FROM ENDEFILI
               WHERE (CDFILIAL     = @P_CDFILIAPUR) AND
                     (IDTPENDEFILI = @V_IDENDCFOP);
            END;

            SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P'),
                   @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
            FROM CLIENTE
            WHERE (CDCLIENTE = @P_CDCLIENTE);

            SELECT @V_PAISDEST = MAX(CDPAIS),
                   @V_ESTADEST = MAX(SGESTADO)
            FROM ENDECLIE
            WHERE (CDCLIENTE    = @P_CDCLIENTE) AND
                  (IDTPENDECLIE = @V_IDENDEMIS);

         END;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

         EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE , @V_CDFILIAPUR, 'S', @V_CDTIPOOPER, @V_CDGRUPOFISC;

         /*CALCULO DA ALIQUOTA IMPOSTO*/

         /* ISS */

         EXEC CONSULTA_ALIQUOTA '31', 'S', @V_CDEMPRATAC, @CDPRODUTO, @V_CDINSCATAC, @V_PAISORIG,
                                 @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DTFINAPUR,
                                 @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

         SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

         SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

         /* PIS */

         EXEC CONSULTA_ALIQUOTA '50', 'S', @V_CDEMPRATAC, @CDPRODUTO, @V_CDINSCATAC, @V_PAISORIG,
                                 @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DTFINAPUR,
                                 @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

         SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

         SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

         /* COFINS */

         EXEC CONSULTA_ALIQUOTA '60', 'S', @V_CDEMPRATAC, @CDPRODUTO, @V_CDINSCATAC, @V_PAISORIG,
                                @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRLIQUFATU, @P_DTFINAPUR,
                                @P_CDFILIAPUR, @P_NRLANCTONF, @V_CDGRUPOFISC;

         SELECT @V_VRALIQUTMP = ISNULL(MAX(VRALIQUTMP),0)
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF);

         SET @V_SOMAALQIMP = @V_SOMAALQIMP + @V_VRALIQUTMP;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @P_CDFILIAPUR+@P_NRLANCTONF;

         IF @V_SOMAALQIMP <>  0 BEGIN
            IF @V_IDTAXAADM = 'D' BEGIN  /*POR DENTRO*/
               SET @V_VRRECUIMDES = (@V_SOMAALQIMP / 100);
            END
            ELSE BEGIN                      /*POR FORA*/
               SET @V_VRRECUIMDES = (100 / (100 - @V_SOMAALQIMP));
            END;
        END;

      END;

      SET @V_VRLIQUFATU = (@V_VRLIQUFATU * @V_VRRECUIMDES);
      SET @V_VRTOTADESP = (@V_VRTOTADESP + @V_VRLIQUFATU);

      /*INCLUSO DOS VALORES CALCULADOS PARA DESPESAS ADMINISTRATIVAS*/
      INSERT INTO RELAT_MANDATO
         (CDFILIAL, NRRELATMANDA, NRREGRELMAND, CDCLIENTEMA, CDFILIAPURMA, NRAPURACFAMA,
          CDPRODCMPDES, VRDESNFCMPAP, VRTAXAADMDES, VRTOTADESSTX, VRTOTADESCTX,
          VRPERECIMDES,VRRECUPIMDES, VRTOTDESAPUR)
          VALUES
         (@P_CDFILIPROC, @P_SEQUMAND, @V_CONTADOR, @P_CDCLIENTE, @P_CDFILIAPUR, @P_NRAPURACFAT,
          @CDPRODUTO, @V_VRBASENFCMP, @V_VRTAXAADM, @V_VRTOTDESSTX, @V_VRTOTDESCTX,
          @V_SOMAALQIMP, @V_VRRECUIMDES, @V_VRTOTADESP);

      SET @V_CONTADOR = @V_CONTADOR + 1;

      FETCH NEXT FROM C_DESPADMFATUR INTO  @CDFILIAL, @CDDESPADMFAT, @DTLANCDESFAT,
                                        @VRLANCDESFAT, @CDGRUPOFATUR, @CDPRODUTO,
                                        @DSDESPADMFAT, @VRTAXADMFATU;
   END;
   CLOSE C_DESPADMFATUR;
   DEALLOCATE C_DESPADMFATUR;

   IF (NOT @V_IDNFPRODREV = 'S') AND (@V_IDGEROUNF = 'S')  BEGIN
      /* Gerao do Crdito em Relao a Dotao da Apurao Passada */

      SELECT @V_VRDOTPURPASS = ISNULL(SUM(VRBRUTITEM),0)
      FROM NOTAFISCAL N, ITEMPRODUTO IP
      WHERE  (N.CDFILIEMIT   = @P_CDFILIAPUR)                         AND
             (N.IDSTATUS     <> 'C')                                  AND
             (N.CDTIPOOPER   = '12')                                  AND
             (N.IDENTRSAIDOP = 'S')                                   AND
             (N.DTENTRSAID BETWEEN @P_DTINIAPUR  AND @P_DTFINAPUR)    AND
             (IP.CDFILIAL    = N.CDFILIAL)                            AND
             (IP.NRLANCTONF  = N.NRLANCTONF)                          AND
             (IP.IDTPNFCREDEB   = '4');

      IF @V_VRDOTPURPASS <> 0 BEGIN
         INSERT INTO RELAT_MANDATO
            (CDFILIAL, NRRELATMANDA, NRREGRELMAND, CDCLIENTEMA, CDFILIAPURMA, NRAPURACFAMA,VRDOTACAOAPU)
             VALUES
            (@P_CDFILIPROC, @P_SEQUMAND, @V_CONTADOR, @P_CDCLIENTE, @P_CDFILIAPUR, @P_NRAPURACFAT, @V_VRDOTPURPASS);
      END;
   END;
END
;
